import{s as ve,f as J,o as de}from"../chunks/scheduler.37c15a92.js";import{S as we,i as _e,g as a,s,r as O,A as be,h as o,f as i,c as n,j as me,u as Q,x as r,k as u,y as ye,a as l,v as X,d as Y,t as Z,w as tt,m as Te,n as Le}from"../chunks/index.7cb9c9b8.js";import{T as $e}from"../chunks/Tip.d10b3fc9.js";import{H as zt}from"../chunks/Heading.d3928e2a.js";function Me(et){let c;return{c(){c=Te("Now that we learned the RL framework, how do we solve the RL problem?")},l(g){c=Le(g,"Now that we learned the RL framework, how do we solve the RL problem?")},m(g,_){l(g,c,_)},d(g){g&&i(c)}}}function xe(et){let c,g,_,it,b,lt,p,st,y,At="In other words, how do we build an RL agent that can <strong>select the actions that maximize its expected cumulative reward?</strong>",nt,T,at,L,Bt="The Policy <strong>π</strong> is the <strong>brain of our Agent</strong>, it’s the function that tells us what <strong>action to take given the state we are in.</strong> So it <strong>defines the agent’s behavior</strong> at a given time.",ot,$,Ft='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_1.jpg" alt="Policy"/> <figcaption>Think of policy as the brain of our agent, the function that will tell us the action to take given a state</figcaption>',rt,M,qt="This Policy <strong>is the function we want to learn</strong>, our goal is to find the optimal policy π*, the policy that <strong>maximizes expected return</strong> when the agent acts according to it. We find this π* <strong>through training.</strong>",ut,x,St="There are two approaches to train our agent to find this optimal policy π*:",ct,H,Dt="<li><strong>Directly,</strong> by teaching the agent to learn which <strong>action to take,</strong> given the current state: <strong>Policy-Based Methods.</strong></li> <li>Indirectly, <strong>teach the agent to learn which state is more valuable</strong> and then take the action that <strong>leads to the more valuable states</strong>: Value-Based Methods.</li>",gt,P,pt,C,Nt="In Policy-Based methods, <strong>we learn a policy function directly.</strong>",ft,I,Wt="This function will define a mapping from each state to the best corresponding action. Alternatively, it could define <strong>a probability distribution over the set of possible actions at that state.</strong>",ht,R,Jt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_2.jpg" alt="Policy"/> <figcaption>As we can see here, the policy (deterministic) <b>directly indicates the action to take for each step.</b></figcaption>',mt,k,Kt="We have two types of policies:",vt,j,Ot="<li><em>Deterministic</em>: a policy at a given state <strong>will always return the same action.</strong></li>",dt,G,Qt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_3.jpg" alt="Policy"/> <figcaption>action = policy(state)</figcaption>',wt,f,Xt,_t,E,Yt="<li><em>Stochastic</em>: outputs <strong>a probability distribution over actions.</strong></li>",bt,U,Zt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_5.jpg" alt="Policy"/> <figcaption>policy(actions | state) = probability distribution over the set of actions given the current state</figcaption>',yt,V,te='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy-based.png" alt="Policy Based"/> <figcaption>Given an initial state, our stochastic policy will output probability distributions over the possible actions at that state.</figcaption>',Tt,z,ee="If we recap:",Lt,h,ie,$t,m,le,Mt,A,xt,B,se="In value-based methods, instead of learning a policy function, we <strong>learn a value function</strong> that maps a state to the expected value <strong>of being at that state.</strong>",Ht,F,ne="The value of a state is the <strong>expected discounted return</strong> the agent can get if it <strong>starts in that state, and then acts according to our policy.</strong>",Pt,q,ae="“Act according to our policy” just means that our policy is <strong>“going to the state with the highest value”.</strong>",Ct,v,oe,It,S,re="Here we see that our value function <strong>defined values for each possible state.</strong>",Rt,D,ue='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/value_2.jpg" alt="Value based RL"/> <figcaption>Thanks to our value function, at each step our policy will select the state with the biggest value defined by the value function: -7, then -6, then -5 (and so on) to attain the goal.</figcaption>',kt,N,ce="Thanks to our value function, at each step our policy will select the state with the biggest value defined by the value function: -7, then -6, then -5 (and so on) to attain the goal.",jt,W,ge="If we recap:",Gt,d,pe,Et,w,fe,Ut,K,Vt;return b=new zt({props:{title:"Two main approaches for solving RL problems",local:"two-methods",headingTag:"h1"}}),p=new $e({props:{$$slots:{default:[Me]},$$scope:{ctx:et}}}),T=new zt({props:{title:"The Policy π: the agent’s brain",local:"policy",headingTag:"h2"}}),P=new zt({props:{title:"Policy-Based Methods",local:"policy-based",headingTag:"h2"}}),A=new zt({props:{title:"Value-based methods",local:"value-based",headingTag:"h2"}}),{c(){c=a("meta"),g=s(),_=a("p"),it=s(),O(b.$$.fragment),lt=s(),O(p.$$.fragment),st=s(),y=a("p"),y.innerHTML=At,nt=s(),O(T.$$.fragment),at=s(),L=a("p"),L.innerHTML=Bt,ot=s(),$=a("figure"),$.innerHTML=Ft,rt=s(),M=a("p"),M.innerHTML=qt,ut=s(),x=a("p"),x.textContent=St,ct=s(),H=a("ul"),H.innerHTML=Dt,gt=s(),O(P.$$.fragment),pt=s(),C=a("p"),C.innerHTML=Nt,ft=s(),I=a("p"),I.innerHTML=Wt,ht=s(),R=a("figure"),R.innerHTML=Jt,mt=s(),k=a("p"),k.textContent=Kt,vt=s(),j=a("ul"),j.innerHTML=Ot,dt=s(),G=a("figure"),G.innerHTML=Qt,wt=s(),f=a("img"),_t=s(),E=a("ul"),E.innerHTML=Yt,bt=s(),U=a("figure"),U.innerHTML=Zt,yt=s(),V=a("figure"),V.innerHTML=te,Tt=s(),z=a("p"),z.textContent=ee,Lt=s(),h=a("img"),$t=s(),m=a("img"),Mt=s(),O(A.$$.fragment),xt=s(),B=a("p"),B.innerHTML=se,Ht=s(),F=a("p"),F.innerHTML=ne,Pt=s(),q=a("p"),q.innerHTML=ae,Ct=s(),v=a("img"),It=s(),S=a("p"),S.innerHTML=re,Rt=s(),D=a("figure"),D.innerHTML=ue,kt=s(),N=a("p"),N.textContent=ce,jt=s(),W=a("p"),W.textContent=ge,Gt=s(),d=a("img"),Et=s(),w=a("img"),Ut=s(),K=a("p"),this.h()},l(t){const e=be("svelte-u9bgzb",document.head);c=o(e,"META",{name:!0,content:!0}),e.forEach(i),g=n(t),_=o(t,"P",{}),me(_).forEach(i),it=n(t),Q(b.$$.fragment,t),lt=n(t),Q(p.$$.fragment,t),st=n(t),y=o(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1poqzkt"&&(y.innerHTML=At),nt=n(t),Q(T.$$.fragment,t),at=n(t),L=o(t,"P",{"data-svelte-h":!0}),r(L)!=="svelte-1sury9w"&&(L.innerHTML=Bt),ot=n(t),$=o(t,"FIGURE",{"data-svelte-h":!0}),r($)!=="svelte-wr9ae2"&&($.innerHTML=Ft),rt=n(t),M=o(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-g271gb"&&(M.innerHTML=qt),ut=n(t),x=o(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-7rf0mi"&&(x.textContent=St),ct=n(t),H=o(t,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-1dvt8p7"&&(H.innerHTML=Dt),gt=n(t),Q(P.$$.fragment,t),pt=n(t),C=o(t,"P",{"data-svelte-h":!0}),r(C)!=="svelte-4zn9b3"&&(C.innerHTML=Nt),ft=n(t),I=o(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-oozyd0"&&(I.innerHTML=Wt),ht=n(t),R=o(t,"FIGURE",{"data-svelte-h":!0}),r(R)!=="svelte-1m4eqa9"&&(R.innerHTML=Jt),mt=n(t),k=o(t,"P",{"data-svelte-h":!0}),r(k)!=="svelte-119iy72"&&(k.textContent=Kt),vt=n(t),j=o(t,"UL",{"data-svelte-h":!0}),r(j)!=="svelte-h86bbg"&&(j.innerHTML=Ot),dt=n(t),G=o(t,"FIGURE",{"data-svelte-h":!0}),r(G)!=="svelte-15macrs"&&(G.innerHTML=Qt),wt=n(t),f=o(t,"IMG",{src:!0,alt:!0,width:!0}),_t=n(t),E=o(t,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-1q48317"&&(E.innerHTML=Yt),bt=n(t),U=o(t,"FIGURE",{"data-svelte-h":!0}),r(U)!=="svelte-dxiuol"&&(U.innerHTML=Zt),yt=n(t),V=o(t,"FIGURE",{"data-svelte-h":!0}),r(V)!=="svelte-120mc27"&&(V.innerHTML=te),Tt=n(t),z=o(t,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1uwte4"&&(z.textContent=ee),Lt=n(t),h=o(t,"IMG",{src:!0,alt:!0,width:!0}),$t=n(t),m=o(t,"IMG",{src:!0,alt:!0,width:!0}),Mt=n(t),Q(A.$$.fragment,t),xt=n(t),B=o(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-v48g1w"&&(B.innerHTML=se),Ht=n(t),F=o(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1wvuk6o"&&(F.innerHTML=ne),Pt=n(t),q=o(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-1xwf190"&&(q.innerHTML=ae),Ct=n(t),v=o(t,"IMG",{src:!0,alt:!0,width:!0}),It=n(t),S=o(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-19buk39"&&(S.innerHTML=re),Rt=n(t),D=o(t,"FIGURE",{"data-svelte-h":!0}),r(D)!=="svelte-hm65hv"&&(D.innerHTML=ue),kt=n(t),N=o(t,"P",{"data-svelte-h":!0}),r(N)!=="svelte-4bnt7i"&&(N.textContent=ce),jt=n(t),W=o(t,"P",{"data-svelte-h":!0}),r(W)!=="svelte-1uwte4"&&(W.textContent=ge),Gt=n(t),d=o(t,"IMG",{src:!0,alt:!0,width:!0}),Et=n(t),w=o(t,"IMG",{src:!0,alt:!0,width:!0}),Ut=n(t),K=o(t,"P",{}),me(K).forEach(i),this.h()},h(){u(c,"name","hf:doc:metadata"),u(c,"content",He),J(f.src,Xt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_4.jpg")||u(f,"src",Xt),u(f,"alt","Policy"),u(f,"width","100%"),J(h.src,ie="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/pbm_1.jpg")||u(h,"src",ie),u(h,"alt","Pbm recap"),u(h,"width","100%"),J(m.src,le="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/pbm_2.jpg")||u(m,"src",le),u(m,"alt","Pbm recap"),u(m,"width","100%"),J(v.src,oe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/value_1.jpg")||u(v,"src",oe),u(v,"alt","Value based RL"),u(v,"width","100%"),J(d.src,pe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/vbm_1.jpg")||u(d,"src",pe),u(d,"alt","Vbm recap"),u(d,"width","100%"),J(w.src,fe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/vbm_2.jpg")||u(w,"src",fe),u(w,"alt","Vbm recap"),u(w,"width","100%")},m(t,e){ye(document.head,c),l(t,g,e),l(t,_,e),l(t,it,e),X(b,t,e),l(t,lt,e),X(p,t,e),l(t,st,e),l(t,y,e),l(t,nt,e),X(T,t,e),l(t,at,e),l(t,L,e),l(t,ot,e),l(t,$,e),l(t,rt,e),l(t,M,e),l(t,ut,e),l(t,x,e),l(t,ct,e),l(t,H,e),l(t,gt,e),X(P,t,e),l(t,pt,e),l(t,C,e),l(t,ft,e),l(t,I,e),l(t,ht,e),l(t,R,e),l(t,mt,e),l(t,k,e),l(t,vt,e),l(t,j,e),l(t,dt,e),l(t,G,e),l(t,wt,e),l(t,f,e),l(t,_t,e),l(t,E,e),l(t,bt,e),l(t,U,e),l(t,yt,e),l(t,V,e),l(t,Tt,e),l(t,z,e),l(t,Lt,e),l(t,h,e),l(t,$t,e),l(t,m,e),l(t,Mt,e),X(A,t,e),l(t,xt,e),l(t,B,e),l(t,Ht,e),l(t,F,e),l(t,Pt,e),l(t,q,e),l(t,Ct,e),l(t,v,e),l(t,It,e),l(t,S,e),l(t,Rt,e),l(t,D,e),l(t,kt,e),l(t,N,e),l(t,jt,e),l(t,W,e),l(t,Gt,e),l(t,d,e),l(t,Et,e),l(t,w,e),l(t,Ut,e),l(t,K,e),Vt=!0},p(t,[e]){const he={};e&2&&(he.$$scope={dirty:e,ctx:t}),p.$set(he)},i(t){Vt||(Y(b.$$.fragment,t),Y(p.$$.fragment,t),Y(T.$$.fragment,t),Y(P.$$.fragment,t),Y(A.$$.fragment,t),Vt=!0)},o(t){Z(b.$$.fragment,t),Z(p.$$.fragment,t),Z(T.$$.fragment,t),Z(P.$$.fragment,t),Z(A.$$.fragment,t),Vt=!1},d(t){t&&(i(g),i(_),i(it),i(lt),i(st),i(y),i(nt),i(at),i(L),i(ot),i($),i(rt),i(M),i(ut),i(x),i(ct),i(H),i(gt),i(pt),i(C),i(ft),i(I),i(ht),i(R),i(mt),i(k),i(vt),i(j),i(dt),i(G),i(wt),i(f),i(_t),i(E),i(bt),i(U),i(yt),i(V),i(Tt),i(z),i(Lt),i(h),i($t),i(m),i(Mt),i(xt),i(B),i(Ht),i(F),i(Pt),i(q),i(Ct),i(v),i(It),i(S),i(Rt),i(D),i(kt),i(N),i(jt),i(W),i(Gt),i(d),i(Et),i(w),i(Ut),i(K)),i(c),tt(b,t),tt(p,t),tt(T,t),tt(P,t),tt(A,t)}}}const He='{"title":"Two main approaches for solving RL problems","local":"two-methods","sections":[{"title":"The Policy π: the agent’s brain","local":"policy","sections":[],"depth":2},{"title":"Policy-Based Methods","local":"policy-based","sections":[],"depth":2},{"title":"Value-based methods","local":"value-based","sections":[],"depth":2}],"depth":1}';function Pe(et){return de(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class je extends we{constructor(c){super(),_e(this,c,Pe,xe,ve,{})}}export{je as component};
